package ru.dbotthepony.mc.otm.block.entity.tech

import net.minecraft.core.BlockPos
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.entity.player.Player
import net.minecraft.world.inventory.AbstractContainerMenu
import net.minecraft.world.item.ItemStack
import net.minecraft.world.item.Items
import net.minecraft.world.level.block.state.BlockState
import ru.dbotthepony.mc.otm.block.IDroppableContainer
import ru.dbotthepony.mc.otm.block.entity.MatteryWorkerBlockEntity
import ru.dbotthepony.mc.otm.container.MatteryContainer
import ru.dbotthepony.mc.otm.container.HandlerFilter
import ru.dbotthepony.mc.otm.menu.tech.CobblerMenu
import ru.dbotthepony.mc.otm.registry.MBlockEntities

class CobblerBlockEntity(blockPos: BlockPos, blockState: BlockState)
	: MatteryWorkerBlockEntity<MatteryWorkerBlockEntity.ItemJob>(MBlockEntities.COBBLESTONE_GENERATOR, blockPos, blockState, ::ItemJob), IDroppableContainer {
	override fun createMenu(containerID: Int, inventory: Inventory, ply: Player): AbstractContainerMenu {
		return CobblerMenu(containerID, inventory, this)
	}

	override val droppableContainer = MatteryContainer(this::itemContainerUpdated, CONTAINER_SIZE)

	val handler = droppableContainer.handler(object : HandlerFilter {
		override fun canInsert(slot: Int, stack: ItemStack): Boolean {
			return false
		}
	})

	init {
		exposeItemsGlobally(handler)
		savetable(::droppableContainer, INVENTORY_KEY)
	}

	override fun onJobFinish(job: ItemJob): Status {
		if (!droppableContainer.fullyAddItem(job.itemStack)) {
			return Status.FAILURE_ITEM
		}

		return Status.SUCCESS
	}

	override fun computeNextJob(): Pair<ItemJob?, Any?> {
		return ItemJob(ItemStack(Items.COBBLESTONE), 40.0) to null
	}

	companion object {
		const val CONTAINER_SIZE = 9
	}
}
