package ru.dbotthepony.mc.otm.container

import net.minecraft.world.item.ItemStack

interface HandlerFilter {
	fun canInsert(slot: Int, stack: ItemStack): Boolean {
		return true
	}

	fun canExtract(slot: Int, amount: Int, stack: ItemStack): Boolean {
		return true
	}

	fun preInsert(slot: Int, stack: ItemStack, simulate: Boolean) {}
	fun preExtract(slot: Int, amount: Int, simulate: Boolean) {}

	object OnlyIn : HandlerFilter {
		override fun canInsert(slot: Int, stack: ItemStack): Boolean {
			return true
		}

		override fun canExtract(slot: Int, amount: Int, stack: ItemStack): Boolean {
			return false
		}
	}

	object OnlyOut : HandlerFilter {
		override fun canInsert(slot: Int, stack: ItemStack): Boolean {
			return false
		}

		override fun canExtract(slot: Int, amount: Int, stack: ItemStack): Boolean {
			return true
		}
	}

	object Both : HandlerFilter
}
